/*
 * This software is the proprietary information of nico3000.
 */
package gui.components;

/**
 *
 * @author nico3000
 */
public class ToggleButton extends Component {
    private String text;
    private boolean activated = false;
    private boolean buttonDown = false;

    public ToggleButton(String text) {
        super(REPAINT_ON_RESIZE);
        this.text = text;
    }

    public void setText(String text) {
        this.text = text;
    }
    
    @Override
    protected void repaint() {
        this.setTexture(this.getGui().getDrawer().createButton(this.text, this.getWidth(), this.getHeight(), this.isFocused(), this.isHovered(), this.activated || (this.buttonDown && this.isHovered())));
    }

    @Override
    public void onButtonDown(int button, int x, int y) {
        if(button == 0) {
            this.buttonDown = true;
            this.needsRepaint();
        }
    }

    @Override
    public void onButtonUp(int button, int x, int y, boolean clicked) {
        if(button == 0) {
            if(this.isHovered()) {
                this.activated = !this.activated;
                this.fireAction(this.activated);
            }
            this.buttonDown = false;
            this.needsRepaint();
        }
    }
}
