/*
 * Copyright (C) 2012 nico3000 - All Rights Reserved
 */
package test;

import event.EventData;
import event.EventListener;
import event.EventManager;
import test.EventTest.TestData1;

/**
 * Event Testklasse.
 * @author nico3000
 */
public class EventTest implements EventListener {
    private static EventManager MGR = new EventManager();
    
    public static void main(String argv[]) {
        MGR.register(new EventTest(), TestData1.ID, TestData2.ID);
        
        MGR.queueEvent(new TestData1("Test event string 1"));
        MGR.queueEvent(new TestData2("Test event string 2"));
        MGR.queueEvent(new TestData2("Test event string 3"));
        MGR.queueEvent(new TestData1("Test event string 4"));
        
        MGR.processEvents();
        System.out.println("---");
        MGR.processEvents();
        System.out.println("---");
        MGR.processEvents();
    }

    @Override
    public void trigger(EventData data) {
        if(data instanceof TestData1) {
            System.out.println("TestData1 triggered: " + ((TestData1)data).content);
            MGR.queueEvent(data);
        } else if(data instanceof TestData2) {
            System.out.println("TestData2 triggered: " + ((TestData2)data).content);
        } else {
            System.err.println("unknown event triggered: " + data);
        }
    }
    
    public static class TestData1 extends EventData {
        public static final int ID = 0xa672180e;
        
        private String content;

        public TestData1(String content) {
            this.content = content;
        }

        @Override
        public int getId() {
            return ID;
        }
    }
    
    public static class TestData2 extends EventData {
        public static final int ID = 0xb5a9e351;
        
        private String content;

        public TestData2(String content) {
            this.content = content;
        }

        @Override
        public int getId() {
            return ID;
        }
    }
}
